<template>
  <v-layout>
    <div
      class="d-flex h-100 w-100 pt-3 pb-3 justify-content-center align-items-center"
    >
      <div class="card-main d-flex flex-column w-95 w-sm-75">
        <div
          class="d-flex ml-3 mr-3 p-3 align-items-center justify-content-start border-bottom"
        >
          <plusIcon class="icon-small-squad icon--brown" />
          <span class="text--gray font-large font-bold ml-3"
            >Cadastro de questões</span
          >
        </div>
        <div class="d-flex col-12 pt-3">
          <div class="d-flex flex-column align-items-left w-100 font-small">
            <textarea
              id="institutionEmail"
              class="textarea input-rounded w-100 text--gray"
              placeholder="Enunciado da questão"
              v-model="model.statement"
            ></textarea>
          </div>
        </div>
        <div class="d-flex col-12 mt-3">
          <div class="d-flex w-100 border-top"></div>
        </div>
        <div class="col-12 h-max-300 scrollable pr-1" ref="scrollable">
          <div
            class="d-flex col-12 pt-3 border-left border-right"
            v-for="(statement, index) of answersTmp"
            :key="index"
          >
            <div class="d-flex flex-column align-items-left w-100 font-small">
              <textarea
                :id="'statement' + index"
                class="textarea text-area-answer input-rounded w-100 text--gray"
                placeholder="Resposta"
                v-bind:class="{ 'border-success': statement.correct }"
                v-model="statement.text"
              ></textarea>
            </div>
          </div>
          <div class="d-flex w-100 pt-3 border-left border-right">
            <div class="d-flex flex-column align-items-left col-10 font-small">
              <textarea
                id="statementTemp"
                class="textarea text-area-answer input-rounded w-100 text--gray"
                placeholder="Resposta"
                v-model="answerTemp.text"
              ></textarea>
            </div>
            <div
              class="d-flex flex-column align-items-left justify-content-center col-2 font-small"
            >
              <div>
                <input
                  type="radio"
                  id="correct"
                  name="correct"
                  ref="correct"
                  :value="true"
                  v-on:click="markAnswer"
                />
                <label for="correct">Correta</label>
              </div>
              <div>
                <input
                  type="radio"
                  id="incorrect"
                  ref="incorrect"
                  name="correct"
                  :value="false"
                  v-on:click="markAnswer"
                  checked
                />
                <label for="dewincorrectey">Incorreta</label>
              </div>
            </div>
          </div>
          <div class="d-flex pt-3 pl-3 pr-3 border-left border-right">
            <div class="d-flex col-6 justify-content-start">
              <button
                class="btn d-flex justify-content-center bg-none p-2 pl-4 pr-4 btn text-green font-medium"
                v-on:click="clearStatement"
                title="Limpar"
                :disabled="isAnswerTmpEmpty"
              >
                Limpar
              </button>
            </div>
            <div class="d-flex col-6 justify-content-end">
              <button
                class="btn d-flex justify-content-center bg-none p-2 pl-4 pr-4 btn text-info font-medium"
                title="Adicionar resposta"
                v-on:click="addStatement"
                :disabled="isAnswerTmpEmpty"
              >
                Adicionar
              </button>
            </div>
          </div>
        </div>
        <div class="d-flex pb-3 pt-3 ml-3 mr-3 border-top">
          <div class="d-flex col-6 justify-content-start">
            <button
              class="btn d-flex justify-content-center bg-none p-2 pl-4 pr-4 btn text-green font-medium"
              v-on:click="cancel"
              title="Cancelar"
            >
              Cancelar
            </button>
          </div>
          <div class="d-flex col-6 justify-content-end">
            <button
              class="btn d-flex justify-content-center bg--primary p-2 pl-4 pr-4 btn text-white font-medium"
              title="Salvar instituição"
              v-on:click="save"
            >
              Salvar
            </button>
          </div>
        </div>
      </div>
    </div>
  </v-layout>
</template>
<script>
/*  ======================
 *   Cadastro de Questões
 *  ======================
 */
import VLayout from "@/layouts/Default";
import plusIcon from "@/static/icon/plus.svg";
import Question from "@/models/Question";
import Answer from "@/models/Answer";
import { isEmpty } from "@/utils/StringUtils";

export default {
  name: "login",
  data() {
    return {
      model: new Question(),
      answerTemp: new Answer(),
      answersTmp: []
    };
  },
  validations: {},
  methods: {
    save() {
      const self = this;
      if (self.model.answers.length && self.model.statement) {
        console.warn(self.model.json);
        self.$notify({
          group: "default",
          type: "success",
          title: "Sucesso",
          text: "Questão cadastrada com sucesso!"
        });
        self.model = new Question();
        self.answersTmp = [];
      } else if (!self.model.statement) {
        self.$notify({
          group: "default",
          type: "warn",
          title: "Atenção",
          text: "A descrição é obrigatória!"
        });
      } else {
        self.$notify({
          group: "default",
          type: "warn",
          title: "Atenção",
          text: "Insira pelo menos uma resposta!"
        });
      }
    },
    cancel() {
      const self = this;
      self.model = new Question();
      self.answersTmp = [];
    },
    clearStatement() {
      this.answerTemp = new Answer();
    },
    addStatement() {
      const self = this;
      self.model.answers.push(self.answerTemp.json);
      self.answersTmp.push(self.answerTemp.json);
      self.answerTemp = new Answer();
      self.$refs.incorrect.checked = true;
    },
    markAnswer(event) {
      const self = this;
      self.answerTemp.correct = event.target.value;
    }
  },
  updated() {
    const self = this;
    self.$refs.scrollable.scrollTop += self.$refs.scrollable.scrollHeight;
  },
  beforeMount() {
    const self = this;
    if (self.$route.params.obj) {
      self.model.montaModel(self.$route.params.obj);
    }
  },
  computed: {
    isAnswerTmpEmpty() {
      return isEmpty(this.answerTemp.text);
    },
    isAnswerTmpCorrect() {
      console.warn(this.answerTemp.correct);
      return this.answerTemp.correct;
    }
  },
  components: {
    VLayout,
    plusIcon
  }
};
</script>
